/*  This is the header file for a DIMACS priority queue interface  */
/*  Include this file if you want to use priority queue routines.  */ 

/*------------------------------------------------------------------*/ 
#include "dc_instantiate.h"

        /*  The file pq_instantiate.h defines the key               */
        /*  type ky_type and the info type in_type.                 */
        /*  It contains a compiler switch for INTEGER_KEY or STRING_KEY */ 
        /*  It also contains macros for                             */
        /*     IN_ASSIGN (a b)  and                                 */
        /*     KY_ASSIGN (a b), type-specific for ``a gets b''      */
        /*  It also contains a macro for KY_COMPARE (a b) with value*/ 
        /*         zero if a = b;                                   */ 
        /*         a positive if a > b                              */ 
        /*         a negative if a < b                              */ 

/*------------------------------------------------------------------*/
#include "dc_types.h"     

        /*  The file dc_types.h defines types used in the dictionary */
        /*  implementations.  Two are avialable to users, namely     */
        /*   it_type, which locates an item in a dictionary          */
        /*   dict_ptr,  which points to a dictionary                   */ 
      
/*-------------------------------------------------------------------*/ 
extern dict_ptr    construct_dict(); 
extern it_type     insert       (dict_ptr D, ky_type key, in_type in);
extern it_type     lookup       (dict_ptr D, ky_type key); 
extern void        delete       (dict_ptr D, ky_type key); 
extern void        del_item     (dict_ptr D, it_type item);

#ifdef STRING_KEY
extern ky_type     *keyval       (dict_ptr D, it_type item);
#endif
#ifdef INTEGER_KEY 
extern ky_type     keyval       (dict_ptr D, it_type item);
#endif  

extern in_type     *infoval     (dict_ptr D, it_type item);
extern int         size         (dict_ptr D); 
extern void        clear        (dict_ptr D); 
extern dict_ptr    destruct_dict(dict_ptr D); 

         /* The dc implementor provides the above routines.           */ 



